var elem = document.getElementById('myCanvas'),
    elemLeft = elem.offsetLeft,
    elemTop = elem.offsetTop,
    context = elem.getContext('2d'),
    screen_main = [],
    screen_mairie=[],
    screen_bureaux=[],
    screen_archives=[],
    images=[],
    anim=[],
	start_screen=[],
	current_screen =start_screen,
    phase='p0',
	last_click={};

// Add event listener for `click` events.
elem.addEventListener('click', function(event) {
	var x = event.pageX - elemLeft,
	y = event.pageY - elemTop;
	last_click.x=x;
	last_click.y=y;
	current_screen.forEach(function(element) {
	if (y > element.top && y < element.top + element.height && x > element.left && x < element.left + element.width) {
		element.onclick();
	}
});
}, false);

// Add event listener for `mouseOver` and 'mouseOut' events.
elem.addEventListener('mousemove', function(event) {
	var x = event.pageX - elemLeft,
		y = event.pageY - elemTop;

	current_screen.forEach(function(element) {
	if (y > element.top && y < element.top + element.height && x > element.left && x < element.left + element.width) {
		if(element.tagOver==false){
			element.mouseover();
		}
	}else{
		if(element.tagOver==true){
			element.mouseout();
		}
	}
});
}, false);

// building image list.

images.push({
	id:"irstea",
  src:'https://upload.wikimedia.org/wikipedia/fr/thumb/f/f0/Irstea_%28logo%29.svg/1059px-Irstea_%28logo%29.svg.png'
});
images.push({
	id:'back',
  src:'https://image.flaticon.com/icons/svg/26/26035.svg'
});
images.push({
	id:'rappel',
  src:'img/rappel.png'
});
images.push({
	id:'mairie',
  src:'img/mairie.png'
});
images.push({
	id:'play',
  src:'img/play_button.png'
});

images.push({
	id:'mairie_select',
  src:'img/mairie_selected.png'
});

images.push({
	id:'mairie_title',
  src:'img/mairie_title.png'
});

images.push({
	id:'etude',
  src:'img/Etude.png'
});

images.push({
	id:'etude_select',
  src:'img/Etude_selected.png'
});
images.push({
	id:'etude_title',
  src:'img/etude_title.png'
});
images.push({
	id:'default_help',
  src:'img/default_help.png'
});
images.push({
	id:'archive_ask',
  src:'img/archive_ask.png'
});
images.push({
	id:'etude_ask',
  src:'img/etude_ask.png'
});
images.push({
	id:'mairie_help',
  src:'img/mairie_help.png'
});
images.push({
	id:'archive_help',
  src:'img/archive_help.png'
});
images.push({
	id:'batiment_help',
  src:'img/batiment_help.png'
});
images.push({
	id:'etude_help',
  src:'img/etude_help.png'
});
images.push({
	id:'tuto_help',
  src:'img/tuto_help.png'
});

images.push({
	id:'planif_help',
  src:'img/planif_help.png'
});


images.push({
	id:'archive',
  src:'img/archive.png'
});

images.push({
	id:'archive_select',
  src:'img/archive_selected.png'
});
images.push({
	id:'archives_title',
  src:'img/archives_title.png'
});

images.push({
	id:'parc',
	src:'img/parc.png'
});
images.push({
	id:'assistant',
	src:'img/assistant.png'
});
images.push({
	id:'planif_button',
	src:'img/planif_button.png'
});
images.push({
	id:'tuto_button',
	src:'img/tuto_button.png'
});





//building screens

start_screen.push({
	id:"play",
    img: 'play',
    width: 443,
    height: 100,
    top: 300,
    left: 430,
    onclick:function(){
    	select_screen(this);
    }
});
var help={
	id:"help",
    img: 'default_help',
    width: 300,
    height: 400,
    top: 0,
    left: 1150
}
screen_main.push(help);
screen_mairie.push(help);
screen_archives.push(help);
screen_bureaux.push(help);

var rappel={
	id:"rappel",
    img: 'rappel',
    width: 248,
    height: 218,
    top: 0,
    left: 1200
}
screen_main.push(rappel);
screen_mairie.push(rappel);
screen_archives.push(rappel);
screen_bureaux.push(rappel);
var ask={
	id:"ask",
    width: 700,
    height: 387,
    top: 650,
    left: 10
};
screen_main.push(ask);
screen_mairie.push(ask);
screen_archives.push(ask);
screen_bureaux.push(ask);

var assistant={
	id:"assistant",
    img: 'assistant',
    width: 82,
    height: 186,
    top: 410,
    left: 1370
}
screen_main.push(assistant);
screen_mairie.push(assistant);
screen_archives.push(assistant);
screen_bureaux.push(assistant);

screen_mairie.push({
	id:"mairie_title",
    img: 'mairie_title',
    width: 213,
    height: 100,
    top: 30,
    left: 580
});

screen_archives.push({
	id:"archives_title",
    img: 'archives_title',
    width: 284,
    height: 100,
    top: 30,
    left: 500
});

screen_bureaux.push({
	id:"etude_title",
    img: 'etude_title',
    width: 273,
    height: 140,
    top: 30,
    left: 500
});

screen_main.push({
		id:"mairie",
    tagOver:false,
    img: 'mairie',
    switched_img:'mairie_select',
    width: 248,
    height: 218,
    top: 50,
    left: 430,
    mouseover:function(){
    	this.tagOver=true;
    	help.img='mairie_help';
    	ask.img='mairie_ask';
    	img_switch(this);
    },
    mouseout:function(){
    	this.tagOver=false;
    	help.img='default_help';
    	ask.img=null;
      	img_switch(this);
    },
    onclick:function(){
    	select_screen(this);
    }
});
var parc={
		id:"parc",
    img: 'parc',
 	width: 250,
    height: 250,
    srcWidth:500,
    srcHeight:500,
    top: 320,
    left: 420,
	current:0,
	total_frames:2,
	anim:true,
	screen:screen_main
};
anim.push(parc);
screen_main.push(parc);

screen_main.push({
		id:"archives",
    tagOver:false,
    img: 'archive',
    switched_img:'archive_select',
    width: 127,
    height: 170,
    top: 350,
    left: 60,
    mouseover:function(){
    	help.img='archive_help'
    	ask.img='archive_ask';
    	this.tagOver=true;
    	img_switch(this);
    },
    mouseout:function(){
    	this.tagOver=false;
    	help.img='default_help';
    	ask.img=null;
      	img_switch(this);
    },
    onclick:function(){
    	select_screen(this);
    }
});
screen_main.push({
	id:"bureaux",
    tagOver:false,
    img: 'etude',
    switched_img:'etude_select',
    width: 149,
    height: 253,
    top: 350,
    left: 865,
    mouseover:function(){
    	this.tagOver=true;
    	help.img='etude_help';
    	ask.img='etude_ask';
    	img_switch(this);
    },
    mouseout:function(){
    	this.tagOver=false;
    	help.img='default_help';
    	ask.img=null;
      img_switch(this);
    },
    onclick:function(){
    	select_screen(this);
    }
});

screen_mairie.push({
		id:"back",
    img: 'back',
    width: 80,
    height: 80,
    top: 490,
    left: 1024,
    onclick:function(){
    	select_screen(this);
    }
})
screen_mairie.push({
		id:"mairie",
    img: 'mairie',
    width: 372,
    height: 327,
    top: 166,
    left: 10,
})
screen_mairie.push({
		id:"planif",
    img: 'planif_button',
    width: 322,
    height: 66,
    top: 166,
    left: 530,
	tagOver:false,
	mouseover:function(){
    	this.tagOver=true;
    	help.img='planif_help';
		draw();
    	
    },
    mouseout:function(){
    	this.tagOver=false;
    	help.img='batiment_help';
		draw();
    },
})
screen_mairie.push({
		id:"tuto",
    img: 'tuto_button',
    width: 322,
    height: 66,
    top: 300,
    left: 530,
	tagOver:false,
	mouseover:function(){
    	this.tagOver=true;
    	help.img='tuto_help';
    	draw();
    },
    mouseout:function(){
    	this.tagOver=false;
    	help.img='batiment_help';
		draw();
    },
})

screen_archives.push({
		id:"back",
    img: 'back',
    width: 80,
    height: 80,
    top: 490,
    left: 1024,
    onclick:function(){
    	select_screen(this);
    }
})
screen_archives.push({
		id:"archive",
    img: 'archive',
    width: 190,
    height: 255,
    top: 166,
    left: 10,
})

screen_bureaux.push({
		id:"back",
    img: 'back',
    width: 80,
    height: 80,
    top: 490,
    left: 1024,
    onclick:function(){
    	select_screen(this);
    }
})
screen_bureaux.push({
		id:"bureau",
    img: 'etude',
    width: 223,
    height: 379,
    top: 166,
    left: 10,
})

// Render elements.

function draw(){
	switch(phase){
		case 'p0':
			draw_p0();
			break;
		case 'p1':
			draw_p1();
			break;
		case 'p2':
			draw_p2();
			break;
	}
	current_screen.forEach(function(element) {
		images.forEach(function(img){
			if(img.id==element.img){
				if(element.anim==true){
					context.drawImage(img.img, element.current * element.srcWidth, 0,element.srcWidth, element.srcHeight,element.left, element.top, element.width, element.height);
				}else{
					context.drawImage(img.img,element.left,element.top,element.width,element.height);
				}
			}
		})
		
	});
}

function draw_p0 (){
	context.fillStyle = "white";
	context.fillRect(0,0,1500,750);	
	

};

function draw_p1 (){
	context.fillStyle = "white";
	context.fillRect(0,0,1500,750);
	context.strokeStyle = "black";
	context.strokeRect(0,0,1500,750);
	context.strokeRect(1175,0,1500,625);
	context.strokeRect(0,625,1500,750);
};

function img_switch(elem){
  	var img = elem.img
    elem.img=elem.switched_img;
    elem.switched_img=img;
    
    draw();
  };
  
function select_screen(elem){
	help.img='batiment_help';
	switch(elem.id){
		case "play":
			current_screen=screen_main;
			help.img='default_help';
			phase='p1';
	  	case "back":	
	  		current_screen=screen_main;
			help.img='default_help';
		 break;
		 case "mairie":
		 	current_screen=screen_mairie;
		 break;
		 case "bureaux":
		 	current_screen=screen_bureaux;
		 break;
		 case "archives":
		 	current_screen=screen_archives;
		 break;
  	}
  	draw();
	current_screen.forEach(function(element) {
		if (last_click.y > element.top && last_click.y < element.top + element.height && last_click.x > element.left && last_click.x < element.left + element.width) {
			if(element.tagOver==false){
				element.mouseover();
			}
		}else{
			if(element.tagOver==true){
				element.mouseout();
			}
		}
	})
};


function preLoad(){
	var sizeLoad = images.length,
		loaded=0;

	images.forEach(function(element){
  		element.img= new Image();
		element.img.addEventListener('load',function(){
			loaded++;
			loadAnim(sizeLoad,loaded);
		})
    	element.img.src=element.src;
  	})
}


function loadAnim(maxi,cur){
	context.strokeStyle='black';
	context.fillStyle='black';
	context.strokeRect(625,365,250,20);
	context.fillRect(625,365,250*cur/maxi,20);
	if(maxi==cur){
		draw();
		draw_anim();
	}
}	

function draw_anim(){
	anim.forEach(function(element){
		if(element.screen==current_screen){
			images.forEach(function(img){
				if(img.id==element.img){
					context.drawImage(img.img, element.current * element.srcWidth, 0,element.srcWidth, element.srcHeight,element.left, element.top, element.width, element.height);
					element.current = (element.current + 1) % element.total_frames;
				}
			})
		}
	})
}
		
preLoad();
setInterval(function () {draw_anim();}, 1500);
